import 'package:flutter/material.dart';
import 'package:get/get.dart';

import 'package:progamification/src/controllers/leader_board.dart';
import 'package:progamification/src/services/sas_token.service.dart';

class LeaderBoardTable extends StatefulWidget {
  const LeaderBoardTable({super.key});

  @override
  State<LeaderBoardTable> createState() => _LeaderBoardTableState();
}

class _LeaderBoardTableState extends State<LeaderBoardTable> {
  LeaderBoardController leaderBoardController =
      Get.find<LeaderBoardController>();
  SasTokenService sasTokenService = Get.find<SasTokenService>();
  String sasToken = "";

  @override
  initState() {
    super.initState();
    sasTokenService.getSasToken().then((value) {
      setState(() {
        sasToken = value.toString();
      });
    });
  }

  @override
  Widget build(BuildContext context) {
    return ListView.builder(
      itemCount: leaderBoardController.leaderBoardData.isNotEmpty
          ? leaderBoardController.leaderBoardData.length
          : 0,
      itemBuilder: (context, i) {
        return leaderBoardController.leaderBoardData.isNotEmpty
            ? Container(
                margin: const EdgeInsets.only(bottom: 2),
                child: ListTile(
                  tileColor: const Color(0xFFd4e2ff),
                  leading: CircleAvatar(
                    backgroundColor: const Color(0xFFcccccc),
                    child: Image.network(
                        leaderBoardController.leaderBoardData[i].profileImageUrl
                                .toString() +
                            sasToken,
                        errorBuilder: (context, error, stackTrace) =>
                            CircleAvatar(
                              backgroundColor: const Color(0xFFcccccc),
                              child: Image.asset(
                                  'assets/icons/profile_placeholder.png',
                                  package: 'progamification'),
                            ),
                        fit: BoxFit.cover),
                  ),
                  title: Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        Expanded(
                            flex: 8,
                            child: Text(
                              leaderBoardController.leaderBoardData[i].userName
                                  .toString(),
                              textAlign: TextAlign.start,
                              style: const TextStyle(
                                fontWeight: FontWeight.w600,
                                fontSize: 16,
                              ),
                            )),
                        Expanded(
                          flex: 2,
                          child: Text(
                            leaderBoardController.leaderBoardData[i].score
                                .toString(),
                            textAlign: TextAlign.start,
                            style: const TextStyle(
                              fontWeight: FontWeight.w600,
                              fontSize: 16,
                            ),
                          ),
                        ),
                      ]),
                  trailing:
                      leaderBoardController.leaderBoardData[i].userReward !=
                              null
                          ? CircleAvatar(
                              backgroundColor: const Color(0xFFd4e2ff),
                              child: Image.network(
                                leaderBoardController.leaderBoardData[i]
                                        .userReward!['sourceImgUrl']
                                        .toString() +
                                    sasToken,
                                errorBuilder: (context, error, stackTrace) =>
                                    Image.asset('assets/icons/no-reward.png',
                                        package: 'progamification'),
                              ),
                            )
                          : CircleAvatar(
                              backgroundColor: const Color(0xFFd4e2ff),
                              child: Image.asset('assets/icons/no-reward.png',
                                  package: 'progamification'),
                            ),
                ),
              )
            : const SizedBox(
                height: 0,
                width: 0,
              );
      },
    );
  }
}
