import 'package:flutter/material.dart';
import 'package:progamification/src/controllers/leader_board.dart';
import 'package:get/get.dart';

class Progress extends StatefulWidget {
  const Progress({super.key});

  @override
  State<Progress> createState() => _ProgressState();
}

class _ProgressState extends State<Progress> {
  LeaderBoardController leaderBoardController =
      Get.find<LeaderBoardController>();
  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: const EdgeInsets.only(
          left: 16.0, right: 16.0, top: 16.0, bottom: 8.0),
      child: Row(
        mainAxisAlignment: MainAxisAlignment.center,
        children: [
          Container(
            width: 60,
            height: 60,
            decoration: BoxDecoration(
              border: Border.all(color: const Color(0xFF2d6ac2), width: 3),
              shape: BoxShape.circle,
              image: DecorationImage(
                fit: BoxFit.fitWidth,
                image: NetworkImage(leaderBoardController
                    .userRewards["previousReward"]["sourceImgUrl"]),
              ),
            ),
          ),
          Expanded(
              child: LinearProgressIndicator(
            backgroundColor: const Color(0xFFe8ecf8),
            color: const Color(0xFF2d6ac2),
            value:
                int.parse(leaderBoardController.userRewards["progress"]) / 100,
            minHeight: 10,
          )),
          Container(
            width: 60,
            height: 60,
            decoration: BoxDecoration(
              border: Border.all(color: const Color(0xFF2d6ac2), width: 3),
              shape: BoxShape.circle,
              image: DecorationImage(
                fit: BoxFit.fitWidth,
                image: NetworkImage(leaderBoardController
                    .userRewards["nextReward"]["sourceImgUrl"]),
              ),
            ),
          )
        ],
      ),
    );
  }
}
